module Essential
  class Resource
    module List

      def retrieve(sid, fetch: true, headers: @headers)
        me = self.new(sid: sid, headers: headers)
        me.fetch() if fetch
        me
      end

      def list(params: {}, url: nil, headers: @headers)
        return PaginatorProxy.new(self, url: url, params: params, headers: headers)
      end

    end
  end
end
