module Essential
  class Resource
    module Update

      def update(params, headers: @headers)
        params = filter_attrs(params || {})
        params = @params.merge(params) if @params
        params = self.as_json.merge(params)
        params = filter_attrs(params)

        response = self.class.request(
          :put,
          url: self.url,
          params: params,
          headers: headers
        )
        json = JSON.parse(response)
        json = @params.merge(json) if @params
        json = @attrs.merge(json)  if @attrs
        init_from(json)
        self
      end

    end
  end
end
