module Essential
  class Resource
    module Create

      def create(params, headers: @headers)
        params = (params || {}).clone
        params = @params.merge(params) if @params
        params = filter_attrs(params)
        response = request(:post,
                           url: url,
                           params: params,
                           headers: headers)
        json = JSON.parse(response)
        json = @params.merge(json) if @params
        json = @attrs.merge(json)  if @attrs
        from_attributes(json)
      end

    end
  end
end
