module Essential
  class Resource
    module Delete

      def delete(headers: @headers)
        response = self.class.request(:delete, url: self.url, headers: headers)

        if response.nil? || response.empty?
          nil
        else
          json = JSON.parse(response)
          json = @params.merge(json) if @params
          json = @attrs.merge(json)  if @attrs
          init_from(json)
        end
      end

    end
  end
end
